<?php

class Popup {
	
	//---------------------------------------------------------
	//  コントロール設定
	//---------------------------------------------------------
	
	public static function control() {
		
		// コントロール設定を返す
		return array(true, false, 'Connect', false);
		
	}
	
	//---------------------------------------------------------
	//  JavaScript生成
	//---------------------------------------------------------
	
	public static function execute() {
		
		// DBクラスを取得
		$db = $GLOBALS['object']['db'];
		
		////////////////////////////////////////////////////////////
		
		// テーブル名を取得
		$pageTable = $GLOBALS['config']['table']['page'];
		$clickTable = $GLOBALS['config']['table']['click'];
		
		// JavaScriptを初期化
		$js = "var titles = new Array();\n";
		
		// 配列の固定値を設定
		$js .= "titles['page0'] = 'unknown';\n";
		
		// クエリーを作成
		$selectPageQuery = "select id, title from $pageTable;";
		
		// クエリーを実行
		$pageResults = $db->query($selectPageQuery);
		
		// データ取得ループ
		while ($rec = $db->fetch($pageResults)) {
			
			// タイトルをエンコード
			$rec['title'] = self::encodeHTML($rec['title']);
			
			// 配列格納用定義を変数に付け足し
			$js .= "titles['page" . $rec['id'] . "'] = '" . $rec['title'] . "';\n";
			
		}
		
		// クエリーを作成
		$selectClickQuery = "select id, title from $clickTable;";
		
		// クエリーを実行
		$clickResults = $db->query($selectClickQuery);
		
		// データ取得ループ
		while ($rec = $db->fetch($clickResults)) {
			
			// タイトルをエンコード
			$rec['title'] = self::encodeHTML($rec['title']);
			
			// 配列格納用定義を変数に付け足し
			$js .= "titles['click" . $rec['id'] . "'] = '" . $rec['title'] . "';\n";
			
		}
		
		// JavaScript用ヘッダーを出力
		header("Content-type: application/x-javascript; charset=UTF-8");
		
		// JavaScriptを出力
		echo $js;
		
	}
	
	//---------------------------------------------------------
	//  HTML表示用に文字列をエンコード
	//---------------------------------------------------------
	
	public static function encodeHTML($str) {
		
		// 改行コード、タブ、フォームフィードを削除
		$str = preg_replace("/[\r\n\t\f]/", '', $str);
		
		// 実体参照に変換
		$str = htmlspecialchars($str, ENT_QUOTES);
		$str = str_replace(',', '&#44;', $str);
		$str = str_replace('\\', '&#165;', $str);
		
		// 変換後の文字列を返す
		return $str;
		
	}
	
}

