<?php

class Update {
	
	//---------------------------------------------------------
	//  UA-CHのカラムを追加（2.5.x -> 2.6.x）
	//---------------------------------------------------------
	
	public static function update260($db, $visitTable) {
		
		// クエリーを作成
		$query1 = "select count(*) as count from sqlite_master where type = 'table' and name = '$visitTable';";
		
		// クエリーを実行
		$count = $db->queryFetch($query1, 'count');
		
		// テーブルが存在しない時は何もしない（月初）
		if ($count === 0) {
			return;
		}
		
		// クエリーを作成
		$query2 = "PRAGMA table_info($visitTable);";
		
		// クエリーを実行
		$result = $db->query($query2);
		
		// カウンター
		$i = 0;
		
		// データを取得するループ
		while ($rec = $db->fetch($result)) {
			$i += 1;
		}
		
		// カラム追加済の時は何もしない
		if ($i === 26) {
			return;
		}
		
		// クエリーを設定
		$query3 = "alter table $visitTable add column ch_ua text default ''";
		$query4 = "alter table $visitTable add column ch_mobile text default ''";
		
		// クエリーを実行
		$db->query($query3);
		$db->query($query4);
		
	}
	
	//---------------------------------------------------------
	//  DBファイルの拡張子を変更（2.4.x -> 2.5.x）
	//---------------------------------------------------------
	
	public static function update250($dataDir) {
		
		// 旧式のファイルが存在しない時は何もしない
		if (!file_exists($dataDir . '/access_main.db')) {
			return;
		}
		
		// データフォルダのファイル名を取得
		$files = glob($dataDir . '/access*.db');
		
		// ファイル名を取得するループ
		foreach ($files as $file) {
			
			// 変換後のファイル名を設定
			$to = preg_replace('/\.db$/', '_1.sqlite', $file);
			
			// リネームを実行
			rename($file, $to);
			
		}
		
	}
	
	//---------------------------------------------------------
	//  UA統計のバグデータを削除（2.4.3のみ）
	//---------------------------------------------------------
	
	public static function update243($dataDir, $db) {
		
		// テーブル名を取得
		$paramTable = $db->table('param');
		
		// 検索DB名を設定
		$reg = '(access_\d{4}_\d{2}_\d{1}\.sqlite)';
		
		// データフォルダのファイル名を取得
		$files = glob($dataDir . '/access*.sqlite');
		
		// ファイル名を取得するループ
		foreach ($files as $file) {
			
			// マッチした時
			if (preg_match("/$reg/", $file, $m)) {
				
				// DBに追加接続
				$db->attach($m[1]);
				
				// クエリーを作成
				$query = "delete from $paramTable where type = 'mobile' and value not like '%Mobile%';";
				
				// クエリーを実行
				$db->query($query);
				
				// DBの追加接続を解除
				$db->detach();
				
			}
			
		}
		
	}
	
}

